<template>
  <div class="q-pa-md">
    <q-table
      title="Tests Summary"
      :rows="rows"
      no-data-label="Tests summary not found for the period."
      :columns="columns"
      row-key="name"
      :filter="filter">

      <template v-slot:top-right>
        <q-input borderless dense debounce="300" v-model="filter" placeholder="Search">
          <template v-slot:append>
            <q-icon name="search" />
          </template>
        </q-input>
      </template>

      <template v-slot:body="props">
        <q-tr :props="props" @click="onRowClick(props.row)" class="pointer">
          <q-td key="name" :props="props">
            {{ props.row.name }}
          </q-td>

          <q-td key="runs" :props="props">
              {{ props.row.total }}
          </q-td>

          <q-td key="psuccess" :props="props">
            <span class="row no-wrap align-middle">
              {{ this.formatPercent(props.row.psuccess) }} <q-linear-progress rounded size="10px" :value="props.row.psuccess" color="positive" class="q-mt-sm align-middle" />
            </span>
          </q-td>

          <q-td key="pfailed" :props="props">
            <span class="row no-wrap align-middle">
              {{ this.formatPercent(props.row.pfailed) }} <q-linear-progress rounded size="10px" :value="props.row.pfailed" color="warning" class="q-mt-sm align-middle" />
            </span>
          </q-td>

          <q-td key="perror" :props="props">
            <span class="row no-wrap align-middle">
              {{ this.formatPercent(props.row.perror) }} <q-linear-progress rounded size="10px" :value="props.row.perror" color="negative" class="q-mt-sm align-middle" />
            </span>
          </q-td>

          <q-td key="pskipped" :props="props">
            <span class="row no-wrap align-middle">
              {{ this.formatPercent(props.row.pskipped) }} <q-linear-progress rounded size="10px" :value="props.row.pskipped" color="secondary" class="q-mt-sm align-middle" />
            </span>
          </q-td>

        </q-tr>
      </template>

    </q-table>
  </div>
</template>

<script>

import { ref } from 'vue'

const columns = [
  {
    name: 'name',
    label: 'Test/Class Name',
    align: 'left',
    field: 'name',
    sortable: true
  },
  {
    name: 'runs',
    align: 'center',
    label: '# Runs',
    field: 'total',
    sortable: true
  },
  {
    name: 'psuccess',
    align: 'center',
    label: 'Success',
    field: 'psuccess',
    sortable: true,
  },
  {
    name: 'pfailed',
    align: 'center',
    label: 'Failed',
    field: 'pfailed',
    sortable: true,
  },
  {
    name: 'perror',
    align: 'center',
    label: 'Error',
    field: 'perror',
    sortable: true,
  },
  {
    name: 'pskipped',
    align: 'center',
    label: 'Skipped',
    field: 'pskipped',
    sortable: true,
  },
]

const rows = []

const conf = config()

export default {
  props: {
     dt_to: {type: String},
     dt_from: {type: String}
  },
  data () {
    return {
      filters: undefined,
      filter: ref(''),
      columns,
      rows,
      search: ''
    }
  },
  created() {
    this.filters = {'dt_from': this.dt_from, 'dt_to': this.dt_to}
    this.fetchData()
    this.emitter.on('project.filter.applied', (event_data) => {
      this.filters = event_data
      this.fetchData()
    })
  },
  // mounted() {
  //   let project_id = this.$route.params.id
  //   fetch(conf.I4C_API_SERVER + "/projects/" + project_id + "/tests")
  //     .then(response => response.json())
  //     .then(data => (this.updateSummary(data)));
  // },
  methods: {
    fetchData() {
       this.rows = []
       fetch(this.tests_endpoint)
         .then(response => response.json())
         .then(data => (this.updateSummary(data)));
    },
    onRowClick (row) {
      this.emitter.emit('tests.summary.selected', row)
    },
    formatPercent(value) {
       let percent = value * 100
       return percent.toFixed(2) + '%'
    },
    roundPercent(value, total) {
       return Math.round((value / total) * 100) / 100 
    },
    updateSummary(data) {
      let result = []
      let self = this
      for (const test_name in data) {
         let test_summary = data[test_name]['stats']
         result.push({'name': test_name,
                      'id': data[test_name]['test_id'],
                      'total': test_summary.total,
                      'psuccess': self.roundPercent(test_summary.success, test_summary.total),
                      'pfailed': self.roundPercent(test_summary.failed, test_summary.total),
                      'perror': self.roundPercent(test_summary.error, test_summary.total),
                      'pskipped': self.roundPercent(test_summary.skipped, test_summary.total)})
      }
      this.rows = result
    }
  },
  computed: {
    tests_endpoint() {
      let project_id = this.$route.params.id
      let endpoint = conf.I4C_API_SERVER  + "/projects/" + project_id + "/tests"
      if (this.filters == null) {
          // console.log("Filter is undefined, getting all tests...")
          return endpoint
      }
      //console.log("Filter is defined:", this.filters)

      let dt_from = encodeURIComponent(this.filters.dt_from)
      let dt_to = encodeURIComponent(this.filters.dt_to)
      let in_groups = encodeURIComponent(this.filters.in_groups)
      let query = "?dt_from=" + dt_from + "&dt_to=" + dt_to + "&in_groups=" + in_groups
      return endpoint + query
    }
  }
}
</script>

<style>
.q-mt-sm {
  margin-top: 2px !important;
  margin-left: 8px !important;
}

</style>
